Package org.apache.sysds.runtime.compress.colgroup.dictionary

## Class ADictionary

- java.lang.Object
- - org.apache.sysds.runtime.compress.colgroup.dictionary.ADictionary

- All Implemented Interfaces:
    `Serializable`
  Direct Known Subclasses:
    `Dictionary`, `MatrixBlockDictionary`, `QDictionary`

      public abstract class ADictionary
      extends Object
      implements Serializable

  This dictionary class aims to encapsulate the storage and operations over unique tuple values of a column group.
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ADictionary()` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `abstract void` | `addToEntry​(double[] v, int fr, int to, int nCol)` | Copies and adds the dictionary entry from this dictionary to the d dictionary
    `abstract void` | `addToEntry​(double[] v, int fr, int to, int nCol, int rep)` | copies and adds the dictonary entry from this dictionary yo the d dictionary rep times.
    `abstract void` | `addToEntryVectorized​(double[] v, int f1, int f2, int f3, int f4, int f5, int f6, int f7, int f8, int t1, int t2, int t3, int t4, int t5, int t6, int t7, int t8, int nCol)` |
    `abstract double` | `aggregate​(double init, Builtin fn)` | Aggregate all the contained values, useful in value only computations where the operation is iterating through all values contained in the dictionary.
    `abstract void` | `aggregateCols​(double[] c, Builtin fn, int[] colIndexes)` | Aggregates the columns into the target double array provided.
    `abstract void` | `aggregateColsWithReference​(double[] c, Builtin fn, int[] colIndexes, double[] reference, boolean def)` | Aggregates the columns into the target double array provided.
    `abstract double[]` | `aggregateRows​(Builtin fn, int nCol)` | Aggregate all entries in the rows.
    `abstract double[]` | `aggregateRowsWithDefault​(Builtin fn, double[] defaultTuple)` | Aggregate all entries in the rows of the dictionary with a extra cell in the end that contains the aggregate of the given defaultTuple.
    `abstract double[]` | `aggregateRowsWithReference​(Builtin fn, double[] reference)` | Aggregate all entries in the rows with an offset value reference added.
    `abstract double` | `aggregateWithReference​(double init, Builtin fn, double[] reference, boolean def)` | Aggregate all the contained values, with a reference offset.
    `abstract ADictionary` | `applyScalarOp​(ScalarOperator op)` | Allocate a new dictionary and applies the scalar operation on each cell of the to then return the new dictionary.
    `abstract ADictionary` | `applyScalarOpWithReference​(ScalarOperator op, double[] reference, double[] newReference)` | Allocate a new dictionary and apply the scalar operation on each cell to then return a new dictionary.
    `abstract ADictionary` | `applyUnaryOp​(UnaryOperator op)` | Allocate a new dictionary and apply the unary operator on each cell.
    `abstract ADictionary` | `applyUnaryOpWithReference​(UnaryOperator op, double[] reference, double[] newReference)` | Allocate a new dictionary and apply the scalar operation on each cell to then return a new dictionary.
    `abstract ADictionary` | `binOpLeft​(BinaryOperator op, double[] v, int[] colIndexes)` | Apply binary row operation on the left side in place
    `abstract ADictionary` | `binOpLeftWithReference​(BinaryOperator op, double[] v, int[] colIndexes, double[] reference, double[] newReference)` | Apply the binary operator such that each value is offset by the reference before application.
    `abstract ADictionary` | `binOpRight​(BinaryOperator op, double[] v)` | Apply binary row operation on the right side.
    `abstract ADictionary` | `binOpRight​(BinaryOperator op, double[] v, int[] colIndexes)` | Apply binary row operation on the right side.
    `abstract ADictionary` | `binOpRightWithReference​(BinaryOperator op, double[] v, int[] colIndexes, double[] reference, double[] newReference)` | Apply the binary operator such that each value is offset by the reference before application.
    `CM_COV_Object` | `centralMoment​(ValueFunction fn, int[] counts, int nRows)` | Central moment function to calculate the central moment of this column group.
    `abstract CM_COV_Object` | `centralMoment​(CM_COV_Object ret, ValueFunction fn, int[] counts, int nRows)` | Central moment function to calculate the central moment of this column group.
    `CM_COV_Object` | `centralMomentWithReference​(ValueFunction fn, int[] counts, double reference, int nRows)` | Central moment function to calculate the central moment of this column group with a reference offset on each tuple.
    `abstract CM_COV_Object` | `centralMomentWithReference​(CM_COV_Object ret, ValueFunction fn, int[] counts, double reference, int nRows)` | Central moment function to calculate the central moment of this column group with a reference offset on each tuple.
    `abstract ADictionary` | `clone()` | Returns a deep clone of the dictionary.
    `void` | `colProduct​(double[] res, int[] counts, int[] colIndexes)` | Calculate the column product of the dictionary weighted by counts.
    `abstract void` | `colSum​(double[] c, int[] counts, int[] colIndexes)` | Get the column sum of the values contained in the dictionary
    `abstract void` | `colSumSq​(double[] c, int[] counts, int[] colIndexes)` | Get the column sum of the values contained in the dictionary
    `abstract void` | `colSumSqWithReference​(double[] c, int[] counts, int[] colIndexes, double[] reference)` | Get the column sum of the values contained in the dictionary with an offset reference value added to each cell.
    `abstract boolean` | `containsValue​(double pattern)` | Detect if the dictionary contains a specific value.
    `abstract boolean` | `containsValueWithReference​(double pattern, double[] reference)` | Detect if the dictionary contains a specific value with reference offset.
    `abstract long` | `getExactSizeOnDisk()` | Calculate the space consumption if the dictionary is stored on disk.
    `abstract long` | `getInMemorySize()` | Returns the memory usage of the dictionary.
    `abstract MatrixBlockDictionary` | `getMBDict​(int nCol)` | Get this dictionary as a MatrixBlock dictionary.
    `abstract long` | `getNumberNonZeros​(int[] counts, int nCol)` | Calculate the number of non zeros in the dictionary.
    `abstract long` | `getNumberNonZerosWithReference​(int[] counts, double[] reference, int nRows)` | Calculate the number of non zeros in the dictionary.
    `abstract int` | `getNumberOfValues​(int ncol)` | Get the number of distinct tuples given that the column group has n columns
    `abstract double` | `getSparsity()` | Get the sparsity of the dictionary.
    `abstract String` | `getString​(int colIndexes)` | Get a string representation of the dictionary, that considers the layout of the data.
    `abstract double` | `getValue​(int i)` | Get Specific value contained in the dictionary at index.
    `abstract double[]` | `getValues()` | Get all the values contained in the dictionary as a linearized double array.
    `abstract ADictionary` | `inplaceScalarOp​(ScalarOperator op)` | Applies the scalar operation on the dictionary.
    `abstract boolean` | `isLossy()` | Specify if the Dictionary is lossy.
    `abstract void` | `multiplyScalar​(double v, double[] ret, int off, int dictIdx, int[] cols)` | Multiply the v value with the dictionary entry at dictIdx and add it to the ret matrix at the columns specified in the int array.
    `abstract ADictionary` | `preaggValuesFromDense​(int numVals, int[] colIndexes, int[] aggregateColumns, double[] b, int cut)` | Pre Aggregate values for Right Matrix Multiplication.
    `abstract void` | `product​(double[] ret, int[] counts, int nCol)` | Calculate the product of the dictionary weighted by counts.
    `abstract void` | `productWithDefault​(double[] ret, int[] counts, double[] def, int defCount)` | Calculate the product of the dictionary weighted by counts with a default value added .
    `abstract void` | `productWithReference​(double[] ret, int[] counts, double[] reference, int refCount)` | Calculate the product of the dictionary weighted by counts and offset by reference
    `abstract ADictionary` | `replace​(double pattern, double replace, int nCol)` | Make a copy of the values, and replace all values that match pattern with replacement value.
    `abstract ADictionary` | `replaceWithReference​(double pattern, double replace, double[] reference)` | Make a copy of the values, and replace all values that match pattern with replacement value.
    `abstract ADictionary` | `rexpandCols​(int max, boolean ignore, boolean cast, int nCol)` | Rexpand the dictionary (one hot encode)
    `abstract ADictionary` | `rexpandColsWithReference​(int max, boolean ignore, boolean cast, double reference)` | Rexpand the dictionary (one hot encode)
    `abstract ADictionary` | `scaleTuples​(int[] scaling, int nCol)` | Scale all tuples contained in the dictionary by the scaling factor given in the int list.
    `abstract ADictionary` | `sliceOutColumnRange​(int idxStart, int idxEnd, int previousNumberOfColumns)` | Modify the dictionary by removing columns not within the index range.
    `abstract ADictionary` | `subtractTuple​(double[] tuple)` | Allocate a new dictionary where the tuple given is subtracted from all tuples in the previous dictionary.
    `abstract double` | `sum​(int[] counts, int nCol)` | Get the sum of the values contained in the dictionary
    `abstract double[]` | `sumAllRowsToDouble​(int nrColumns)` | Method used as a pre-aggregate of each tuple in the dictionary, to single double values.
    `abstract double[]` | `sumAllRowsToDoubleSq​(int nrColumns)` | Method used as a pre-aggregate of each tuple in the dictionary, to single double values.
    `abstract double[]` | `sumAllRowsToDoubleSqWithDefault​(double[] defaultTuple)` | Method used as a pre-aggregate of each tuple in the dictionary, to single double values.
    `abstract double[]` | `sumAllRowsToDoubleSqWithReference​(double[] reference)` | Method used as a pre-aggregate of each tuple in the dictionary, to single double values.
    `abstract double[]` | `sumAllRowsToDoubleWithDefault​(double[] defaultTuple)` | Do exactly the same as the sumAllRowsToDouble but also sum the array given to a extra index in the end of the array.
    `abstract double[]` | `sumAllRowsToDoubleWithReference​(double[] reference)` | Method used as a pre-aggregate of each tuple in the dictionary, to single double values with a reference.
    `abstract double` | `sumSq​(int[] counts, int nCol)` | Get the square sum of the values contained in the dictionary
    `abstract double` | `sumSqWithReference​(int[] counts, double[] reference)` | Get the square sum of the values contained in the dictionary with a reference offset on each value.
    `abstract void` | `write​(DataOutput out)` | Write the dictionary to a DataOutput.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ADictionary

          public ADictionary()

  - ### Method Detail

    - #### getValues

          public abstract double[] getValues()

      Get all the values contained in the dictionary as a linearized double array.
      Returns:
        linearized double array

    - #### getValue

          public abstract double getValue​(int i)

      Get Specific value contained in the dictionary at index.
      Parameters:
        `i` - The index to extract the value from
      Returns:
        The value contained at the index

    - #### getInMemorySize

          public abstract long getInMemorySize()

      Returns the memory usage of the dictionary.
      Returns:
        a long value in number of bytes for the dictionary.

    - #### aggregate

          public abstract double aggregate​(double init,
                                           Builtin fn)

      Aggregate all the contained values, useful in value only computations where the operation is iterating through all values contained in the dictionary.
      Parameters:
        `init` - The initial Value, in cases such as Max value, this could be -infinity
        `fn` - The Function to apply to values
      Returns:
        The aggregated value as a double.

    - #### aggregateWithReference

          public abstract double aggregateWithReference​(double init,
                                                        Builtin fn,
                                                        double[] reference,
                                                        boolean def)

      Aggregate all the contained values, with a reference offset.
      Parameters:
        `init` - The initial value, in cases such as Max value this could be -infinity.
        `fn` - The function to apply to the values
        `reference` - The reference offset to each value in the dictionary
        `def` - If the reference should be treated as an instance of only as reference
      Returns:
        The aggregated value as a double.

    - #### aggregateRows

          public abstract double[] aggregateRows​(Builtin fn,
                                                 int nCol)

      Aggregate all entries in the rows.
      Parameters:
        `fn` - The aggregate function
        `nCol` - The number of columns contained in the dictionary.
      Returns:
        Aggregates for this dictionary tuples.

    - #### aggregateRowsWithDefault

          public abstract double[] aggregateRowsWithDefault​(Builtin fn,
                                                            double[] defaultTuple)

      Aggregate all entries in the rows of the dictionary with a extra cell in the end that contains the aggregate of the given defaultTuple.
      Parameters:
        `fn` - The aggregate function
        `defaultTuple` - The default tuple to aggregate in last cell
      Returns:
        Aggregates for this dictionary tuples.

    - #### aggregateRowsWithReference

          public abstract double[] aggregateRowsWithReference​(Builtin fn,
                                                              double[] reference)

      Aggregate all entries in the rows with an offset value reference added.
      Parameters:
        `fn` - The aggregate function
        `reference` - The reference offset to each value in the dictionary
      Returns:
        Aggregates for this dictionary tuples.

    - #### aggregateCols

          public abstract void aggregateCols​(double[] c,
                                             Builtin fn,
                                             int[] colIndexes)

      Aggregates the columns into the target double array provided.
      Parameters:
        `c` - The target double array, this contains the full number of columns, therefore the colIndexes for this specific dictionary is needed.
        `fn` - The function to apply to individual columns
        `colIndexes` - The mapping to the target columns from the individual columns

    - #### aggregateColsWithReference

          public abstract void aggregateColsWithReference​(double[] c,
                                                          Builtin fn,
                                                          int[] colIndexes,
                                                          double[] reference,
                                                          boolean def)

      Aggregates the columns into the target double array provided.
      Parameters:
        `c` - The target double array, this contains the full number of columns, therefore the colIndexes for this specific dictionary is needed.
        `fn` - The function to apply to individual columns
        `reference` - The reference offset values to add to each cell.
        `colIndexes` - The mapping to the target columns from the individual columns
        `def` - If the reference should be treated as a tuple as well

    - #### applyScalarOp

          public abstract ADictionary applyScalarOp​(ScalarOperator op)

      Allocate a new dictionary and applies the scalar operation on each cell of the to then return the new dictionary.
      Parameters:
        `op` - The operator.
      Returns:
        The new dictionary to return.

    - #### applyUnaryOp

          public abstract ADictionary applyUnaryOp​(UnaryOperator op)

      Allocate a new dictionary and apply the unary operator on each cell.
      Parameters:
        `op` - the operator.
      Returns:
        The new dictionary to return.

    - #### applyScalarOpWithReference

          public abstract ADictionary applyScalarOpWithReference​(ScalarOperator op,
                                                                 double[] reference,
                                                                 double[] newReference)

      Allocate a new dictionary and apply the scalar operation on each cell to then return a new dictionary. outValues[j] = op(this.values[j] + reference[i]) - newReference[i]
      Parameters:
        `op` - The operator to apply to each cell.
        `reference` - The reference value to add before the operator.
        `newReference` - The reference value to subtract after the operator.
      Returns:
        A New Dictionary.

    - #### applyUnaryOpWithReference

          public abstract ADictionary applyUnaryOpWithReference​(UnaryOperator op,
                                                                double[] reference,
                                                                double[] newReference)

      Allocate a new dictionary and apply the scalar operation on each cell to then return a new dictionary. outValues[j] = op(this.values[j] + reference[i]) - newReference[i]
      Parameters:
        `op` - The unary operator to apply to each cell.
        `reference` - The reference value to add before the operator.
        `newReference` - The reference value to subtract after the operator.
      Returns:
        A New Dictionary.

    - #### inplaceScalarOp

          public abstract ADictionary inplaceScalarOp​(ScalarOperator op)

      Applies the scalar operation on the dictionary. Note that this operation modifies the underlying data, and normally require a copy of the original Dictionary to preserve old objects.
      Parameters:
        `op` - The operator to apply to the dictionary values.
      Returns:
        this dictionary with modified values.

    - #### binOpLeft

          public abstract ADictionary binOpLeft​(BinaryOperator op,
                                                double[] v,
                                                int[] colIndexes)

      Apply binary row operation on the left side in place
      Parameters:
        `op` - The operation to this dictionary
        `v` - The values to use on the left hand side.
        `colIndexes` - The column indexes to consider inside v.
      Returns:
        A new dictionary containing the updated values.

    - #### binOpLeftWithReference

          public abstract ADictionary binOpLeftWithReference​(BinaryOperator op,
                                                             double[] v,
                                                             int[] colIndexes,
                                                             double[] reference,
                                                             double[] newReference)

      Apply the binary operator such that each value is offset by the reference before application. Then put the result into the new dictionary, but offset it by the new reference. outValues[j] = op(v[colIndexes[i]], this.values[j] + reference[i]) - newReference[i]
      Parameters:
        `op` - The operation to apply on the dictionary values.
        `v` - The values to use on the left side of the operator.
        `colIndexes` - The column indexes to use.
        `reference` - The reference value to add before operator.
        `newReference` - The reference value to subtract after operator.
      Returns:
        A new dictionary.

    - #### binOpRight

          public abstract ADictionary binOpRight​(BinaryOperator op,
                                                 double[] v,
                                                 int[] colIndexes)

      Apply binary row operation on the right side.
      Parameters:
        `op` - The operation to this dictionary
        `v` - The values to use on the right hand side.
        `colIndexes` - The column indexes to consider inside v.
      Returns:
        A new dictionary containing the updated values.

    - #### binOpRight

          public abstract ADictionary binOpRight​(BinaryOperator op,
                                                 double[] v)

      Apply binary row operation on the right side.
      Parameters:
        `op` - The operation to this dictionary
        `v` - The values to apply on the dictionary (same number of cols as the dictionary)
      Returns:
        A new dictionary containing the updated values.

    - #### binOpRightWithReference

          public abstract ADictionary binOpRightWithReference​(BinaryOperator op,
                                                              double[] v,
                                                              int[] colIndexes,
                                                              double[] reference,
                                                              double[] newReference)

      Apply the binary operator such that each value is offset by the reference before application. Then put the result into the new dictionary, but offset it by the new reference. outValues[j] = op(this.values[j] + reference[i], v[colIndexes[i]]) - newReference[i]
      Parameters:
        `op` - The operation to apply on the dictionary values.
        `v` - The values to use on the right side of the operator.
        `colIndexes` - The column indexes to use.
        `reference` - The reference value to add before operator.
        `newReference` - The reference value to subtract after operator.
      Returns:
        A new dictionary.

    - #### clone

          public abstract ADictionary clone()

      Returns a deep clone of the dictionary.

    - #### write

          public abstract void write​(DataOutput out)
                              throws IOException

      Write the dictionary to a DataOutput.
      Parameters:
        `out` - the output sink to write the dictionary to.
      Throws:
        `IOException` - if the sink fails.

    - #### getExactSizeOnDisk

          public abstract long getExactSizeOnDisk()

      Calculate the space consumption if the dictionary is stored on disk.
      Returns:
        the long count of bytes to store the dictionary.

    - #### isLossy

          public abstract boolean isLossy()

      Specify if the Dictionary is lossy.
      Returns:
        A boolean

    - #### getNumberOfValues

          public abstract int getNumberOfValues​(int ncol)

      Get the number of distinct tuples given that the column group has n columns
      Parameters:
        `ncol` - The number of Columns in the ColumnGroup.
      Returns:
        the number of value tuples contained in the dictionary.

    - #### sumAllRowsToDouble

          public abstract double[] sumAllRowsToDouble​(int nrColumns)

      Method used as a pre-aggregate of each tuple in the dictionary, to single double values. Note if the number of columns is one the actual dictionaries values are simply returned.
      Parameters:
        `nrColumns` - The number of columns in the ColGroup to know how to get the values from the dictionary.
      Returns:
        a double array containing the row sums from this dictionary.

    - #### sumAllRowsToDoubleWithDefault

          public abstract double[] sumAllRowsToDoubleWithDefault​(double[] defaultTuple)

      Do exactly the same as the sumAllRowsToDouble but also sum the array given to a extra index in the end of the array.
      Parameters:
        `defaultTuple` - The default row to sum in the end index returned.
      Returns:
        a double array containing the row sums from this dictionary.

    - #### sumAllRowsToDoubleWithReference

          public abstract double[] sumAllRowsToDoubleWithReference​(double[] reference)

      Method used as a pre-aggregate of each tuple in the dictionary, to single double values with a reference.
      Parameters:
        `reference` - The reference values to add to each cell.
      Returns:
        a double array containing the row sums from this dictionary.

    - #### sumAllRowsToDoubleSq

          public abstract double[] sumAllRowsToDoubleSq​(int nrColumns)

      Method used as a pre-aggregate of each tuple in the dictionary, to single double values. Note if the number of columns is one the actual dictionaries values are simply returned.
      Parameters:
        `nrColumns` - The number of columns in the ColGroup to know how to get the values from the dictionary.
      Returns:
        a double array containing the row sums from this dictionary.

    - #### sumAllRowsToDoubleSqWithDefault

          public abstract double[] sumAllRowsToDoubleSqWithDefault​(double[] defaultTuple)

      Method used as a pre-aggregate of each tuple in the dictionary, to single double values. But adds another cell to the return with an extra value that is the sum of the given defaultTuple.
      Parameters:
        `defaultTuple` - The default row to sum in the end index returned.
      Returns:
        a double array containing the row sums from this dictionary.

    - #### sumAllRowsToDoubleSqWithReference

          public abstract double[] sumAllRowsToDoubleSqWithReference​(double[] reference)

      Method used as a pre-aggregate of each tuple in the dictionary, to single double values.
      Parameters:
        `reference` - The reference values to add to each cell.
      Returns:
        a double array containing the row sums from this dictionary.

    - #### colSum

          public abstract void colSum​(double[] c,
                                      int[] counts,
                                      int[] colIndexes)

      Get the column sum of the values contained in the dictionary
      Parameters:
        `c` - The output array allocated to contain all column groups output.
        `counts` - The counts of the individual tuples.
        `colIndexes` - The columns indexes of the parent column group, this indicate where to put the column sum into the c output.

    - #### colSumSq

          public abstract void colSumSq​(double[] c,
                                        int[] counts,
                                        int[] colIndexes)

      Get the column sum of the values contained in the dictionary
      Parameters:
        `c` - The output array allocated to contain all column groups output.
        `counts` - The counts of the individual tuples.
        `colIndexes` - The columns indexes of the parent column group, this indicate where to put the column sum into the c output.

    - #### colSumSqWithReference

          public abstract void colSumSqWithReference​(double[] c,
                                                     int[] counts,
                                                     int[] colIndexes,
                                                     double[] reference)

      Get the column sum of the values contained in the dictionary with an offset reference value added to each cell.
      Parameters:
        `c` - The output array allocated to contain all column groups output.
        `counts` - The counts of the individual tuples.
        `colIndexes` - The columns indexes of the parent column group, this indicate where to put the column sum into the c output.
        `reference` - The reference values to add to each cell.

    - #### sum

          public abstract double sum​(int[] counts,
                                     int nCol)

      Get the sum of the values contained in the dictionary
      Parameters:
        `counts` - The counts of the individual tuples
        `nCol` - The number of columns contained
      Returns:
        The sum scaled by the counts provided.

    - #### sumSq

          public abstract double sumSq​(int[] counts,
                                       int nCol)

      Get the square sum of the values contained in the dictionary
      Parameters:
        `counts` - The counts of the individual tuples
        `nCol` - The number of columns contained
      Returns:
        The square sum scaled by the counts provided.

    - #### sumSqWithReference

          public abstract double sumSqWithReference​(int[] counts,
                                                    double[] reference)

      Get the square sum of the values contained in the dictionary with a reference offset on each value.
      Parameters:
        `counts` - The counts of the individual tuples
        `reference` - The reference value
      Returns:
        The square sum scaled by the counts and reference.

    - #### getString

          public abstract String getString​(int colIndexes)

      Get a string representation of the dictionary, that considers the layout of the data.
      Parameters:
        `colIndexes` - The number of columns in the dictionary.
      Returns:
        A string that is nicer to print.

    - #### sliceOutColumnRange

          public abstract ADictionary sliceOutColumnRange​(int idxStart,
                                                          int idxEnd,
                                                          int previousNumberOfColumns)

      Modify the dictionary by removing columns not within the index range.
      Parameters:
        `idxStart` - The column index to start at.
        `idxEnd` - The column index to end at (not inclusive)
        `previousNumberOfColumns` - The number of columns contained in the dictionary.
      Returns:
        A dictionary containing the sliced out columns values only.

    - #### containsValue

          public abstract boolean containsValue​(double pattern)

      Detect if the dictionary contains a specific value.
      Parameters:
        `pattern` - The value to search for
      Returns:
        true if the value is contained else false.

    - #### containsValueWithReference

          public abstract boolean containsValueWithReference​(double pattern,
                                                             double[] reference)

      Detect if the dictionary contains a specific value with reference offset.
      Parameters:
        `pattern` - The pattern/ value to search for
        `reference` - The reference double array.
      Returns:
        true if the value is contained else false.

    - #### getNumberNonZeros

          public abstract long getNumberNonZeros​(int[] counts,
                                                 int nCol)

      Calculate the number of non zeros in the dictionary. The number of non zeros should be scaled with the counts given. This gives the exact number of non zero values in the parent column group.
      Parameters:
        `counts` - The counts of each dictionary entry
        `nCol` - The number of columns in this dictionary
      Returns:
        The nonZero count

    - #### getNumberNonZerosWithReference

          public abstract long getNumberNonZerosWithReference​(int[] counts,
                                                              double[] reference,
                                                              int nRows)

      Calculate the number of non zeros in the dictionary. Each value in the dictionary should be added to the reference value. The number of non zeros should be scaled with the given counts.
      Parameters:
        `counts` - The Counts of each dict entry.
        `reference` - The reference vector.
        `nRows` - The number of rows in the input.
      Returns:
        The NonZero Count.

    - #### addToEntry

          public abstract void addToEntry​(double[] v,
                                          int fr,
                                          int to,
                                          int nCol)

      Copies and adds the dictionary entry from this dictionary to the d dictionary
      Parameters:
        `v` - the target dictionary (dense double array)
        `fr` - the from index
        `to` - the to index
        `nCol` - the number of columns

    - #### addToEntry

          public abstract void addToEntry​(double[] v,
                                          int fr,
                                          int to,
                                          int nCol,
                                          int rep)

      copies and adds the dictonary entry from this dictionary yo the d dictionary rep times.
      Parameters:
        `v` - the target dictionary (dense double array)
        `fr` - the from index
        `to` - the to index
        `nCol` - the number of columns
        `rep` - the number of repetitions to apply (simply multiply do not loop)

    - #### addToEntryVectorized

          public abstract void addToEntryVectorized​(double[] v,
                                                    int f1,
                                                    int f2,
                                                    int f3,
                                                    int f4,
                                                    int f5,
                                                    int f6,
                                                    int f7,
                                                    int f8,
                                                    int t1,
                                                    int t2,
                                                    int t3,
                                                    int t4,
                                                    int t5,
                                                    int t6,
                                                    int t7,
                                                    int t8,
                                                    int nCol)

    - #### subtractTuple

          public abstract ADictionary subtractTuple​(double[] tuple)

      Allocate a new dictionary where the tuple given is subtracted from all tuples in the previous dictionary.
      Parameters:
        `tuple` - a double list representing a tuple, it is given that the tuple with is the same as this dictionaries.
      Returns:
        a new instance of dictionary with the tuple subtracted.

    - #### getMBDict

          public abstract MatrixBlockDictionary getMBDict​(int nCol)

      Get this dictionary as a MatrixBlock dictionary. This allows us to use optimized kernels coded elsewhere in the system, such as matrix multiplication. Return null if the matrix is empty.
      Parameters:
        `nCol` - The number of columns contained in this column group.
      Returns:
        A Dictionary containing a MatrixBlock.

    - #### scaleTuples

          public abstract ADictionary scaleTuples​(int[] scaling,
                                                  int nCol)

      Scale all tuples contained in the dictionary by the scaling factor given in the int list.
      Parameters:
        `scaling` - The amount to multiply the given tuples with
        `nCol` - The number of columns contained in this column group.
      Returns:
        A New dictionary (since we don't want to modify the underlying dictionary)

    - #### preaggValuesFromDense

          public abstract ADictionary preaggValuesFromDense​(int numVals,
                                                            int[] colIndexes,
                                                            int[] aggregateColumns,
                                                            double[] b,
                                                            int cut)

      Pre Aggregate values for Right Matrix Multiplication.
      Parameters:
        `numVals` - The number of values contained in this dictionary
        `colIndexes` - The column indexes that is associated with the parent column group
        `aggregateColumns` - The column to aggregate, this is preprocessed, to find remove consideration for empty columns
        `b` - The values in the right hand side matrix
        `cut` - The number of columns in b.
      Returns:
        A new dictionary with the pre aggregated values.

    - #### replace

          public abstract ADictionary replace​(double pattern,
                                              double replace,
                                              int nCol)

      Make a copy of the values, and replace all values that match pattern with replacement value. If needed add a new column index.
      Parameters:
        `pattern` - The value to look for
        `replace` - The value to replace the other value with
        `nCol` - The number of columns contained in the dictionary.
      Returns:
        A new Column Group, reusing the index structure but with new values.

    - #### replaceWithReference

          public abstract ADictionary replaceWithReference​(double pattern,
                                                           double replace,
                                                           double[] reference)

      Make a copy of the values, and replace all values that match pattern with replacement value. If needed add a new column index. With reference such that each value in the dict is considered offset by the values contained in the reference.
      Parameters:
        `pattern` - The value to look for
        `replace` - The value to replace the other value with
        `reference` - The reference tuple to add to all entries when replacing
      Returns:
        A new Column Group, reusing the index structure but with new values.

    - #### product

          public abstract void product​(double[] ret,
                                       int[] counts,
                                       int nCol)

      Calculate the product of the dictionary weighted by counts.
      Parameters:
        `ret` - The result dense double array (containing one value)
        `counts` - The count of individual tuples
        `nCol` - Number of columns in the dictionary.

    - #### productWithDefault

          public abstract void productWithDefault​(double[] ret,
                                                  int[] counts,
                                                  double[] def,
                                                  int defCount)

      Calculate the product of the dictionary weighted by counts with a default value added .
      Parameters:
        `ret` - The result dense double array (containing one value)
        `counts` - The count of individual tuples
        `def` - The default tuple
        `defCount` - The count of the default tuple

    - #### productWithReference

          public abstract void productWithReference​(double[] ret,
                                                    int[] counts,
                                                    double[] reference,
                                                    int refCount)

      Calculate the product of the dictionary weighted by counts and offset by reference
      Parameters:
        `ret` - The result dense double array (containing one value)
        `counts` - The counts of each entry in the dictionary
        `reference` - The reference value.
        `refCount` - The number of occurences of the ref value.

    - #### colProduct

          public void colProduct​(double[] res,
                                 int[] counts,
                                 int[] colIndexes)

      Calculate the column product of the dictionary weighted by counts.
      Parameters:
        `res` - The result vector to put the result into
        `counts` - The weighted count of individual tuples
        `colIndexes` - The column indexes.

    - #### centralMoment

          public CM_COV_Object centralMoment​(ValueFunction fn,
                                             int[] counts,
                                             int nRows)

      Central moment function to calculate the central moment of this column group. MUST be on a single column dictionary.
      Parameters:
        `fn` - The value function to apply
        `counts` - The weight of individual tuples
        `nRows` - The number of rows in total of the column group
      Returns:
        The central moment Object

    - #### centralMoment

          public abstract CM_COV_Object centralMoment​(CM_COV_Object ret,
                                                      ValueFunction fn,
                                                      int[] counts,
                                                      int nRows)

      Central moment function to calculate the central moment of this column group. MUST be on a single column dictionary.
      Parameters:
        `ret` - The Central Moment object to be modified and returned
        `fn` - The value function to apply
        `counts` - The weight of individual tuples
        `nRows` - The number of rows in total of the column group
      Returns:
        The central moment Object

    - #### centralMomentWithReference

          public CM_COV_Object centralMomentWithReference​(ValueFunction fn,
                                                          int[] counts,
                                                          double reference,
                                                          int nRows)

      Central moment function to calculate the central moment of this column group with a reference offset on each tuple. MUST be on a single column dictionary.
      Parameters:
        `fn` - The value function to apply
        `counts` - The weight of individual tuples
        `reference` - The reference values to offset the tuples with
        `nRows` - The number of rows in total of the column group
      Returns:
        The central moment Object

    - #### centralMomentWithReference

          public abstract CM_COV_Object centralMomentWithReference​(CM_COV_Object ret,
                                                                   ValueFunction fn,
                                                                   int[] counts,
                                                                   double reference,
                                                                   int nRows)

      Central moment function to calculate the central moment of this column group with a reference offset on each tuple. MUST be on a single column dictionary.
      Parameters:
        `ret` - The Central Moment object to be modified and returned
        `fn` - The value function to apply
        `counts` - The weight of individual tuples
        `reference` - The reference values to offset the tuples with
        `nRows` - The number of rows in total of the column group
      Returns:
        The central moment Object

    - #### rexpandCols

          public abstract ADictionary rexpandCols​(int max,
                                                  boolean ignore,
                                                  boolean cast,
                                                  int nCol)

      Rexpand the dictionary (one hot encode)
      Parameters:
        `max` - the tuple width of the output
        `ignore` - If we should ignore zero and negative values
        `cast` - If we should cast all double values to whole integer values
        `nCol` - The number of columns in the dictionary already (should be 1)
      Returns:
        A new dictionary

    - #### rexpandColsWithReference

          public abstract ADictionary rexpandColsWithReference​(int max,
                                                               boolean ignore,
                                                               boolean cast,
                                                               double reference)

      Rexpand the dictionary (one hot encode)
      Parameters:
        `max` - the tuple width of the output
        `ignore` - If we should ignore zero and negative values
        `cast` - If we should cast all double values to whole integer values
        `reference` - A reference value to add to all tuples before expanding
      Returns:
        A new dictionary

    - #### getSparsity

          public abstract double getSparsity()

      Get the sparsity of the dictionary.
      Returns:
        a sparsity between 0 and 1

    - #### multiplyScalar

          public abstract void multiplyScalar​(double v,
                                              double[] ret,
                                              int off,
                                              int dictIdx,
                                              int[] cols)

      Multiply the v value with the dictionary entry at dictIdx and add it to the ret matrix at the columns specified in the int array.
      Parameters:
        `v` - Value to multiply
        `ret` - Output dense double array location
        `off` - Offset into the ret array that the "row" output starts at
        `dictIdx` - The dictionary entry to multiply.
        `cols` - The columns to multiply into of the output.